
BEGIN WORK;

--
-- Tabla de Clases de navios 
--
CREATE TABLE classes(
	class			VARCHAR(24) NOT NULL PRIMARY KEY,
	type			CHAR(2) NOT NULL CHECK (type IN ('bb','bc')),
	country			VARCHAR(24) NOT NULL,
	numGuns			SMALLINT CHECK (numGuns BETWEEN 0 AND 50),
	bore			SMALLINT,
	displacement	INTEGER
);

--
-- Tabla de batallas 
--
CREATE TABLE battles(
	name	VARCHAR(24) NOT NULL PRIMARY KEY,
	date	VARCHAR(17) NOT NULL
);

--
-- Tabla de navios
--
CREATE TABLE ships(
	name		VARCHAR(24) NOT NULL PRIMARY KEY,
	class		VARCHAR(24) NOT NULL REFERENCES classes(class),
	launched	INTEGER NOT NULL CHECK (launched BETWEEN 1400 AND 2000)
);

--
-- Tabla de resultados de batallas
--
CREATE TABLE outcomes(
	ship	VARCHAR(24) NOT NULL, 
	battle	VARCHAR(24) NOT NULL REFERENCES battles(name),
	result	CHAR(7) CHECK (result IN ('ok','sunk','damaged')),
	PRIMARY KEY (ship,battle)
);

COMMIT WORK;
